Attribute VB_Name = "mdlCollision"
Option Explicit

'Detect a precise collision by a position and size of 2 objects
Public Function CollisionPrecise(X1 As Long, Y1 As Long, Width1 As Long, Height1 As Long, X2 As Long, Y2 As Long, Width2 As Long, Height2 As Long) As Boolean
    If (X1 + Width1 >= X2 And X1 <= X2 + Width2) And (Y1 + Height1 >= Y2 And Y1 <= Y2 + Height2) Then
        CollisionPrecise = True
    Else
        CollisionPrecise = False
    End If
End Function

'Detect collision by 2 objects
Public Function Collision(Object1 As Object, Object2 As Object) As Boolean
    Dim X1 As Long
    Dim Y1 As Long
    Dim Width1 As Long
    Dim Height1 As Long
    Dim X2 As Long
    Dim Y2 As Long
    Dim Width2 As Long
    Dim Height2 As Long
    
    X1 = Object1.Left
    Y1 = Object1.Top
    Width1 = Object1.Width
    Height1 = Object1.Height
    X2 = Object2.Left
    Y2 = Object2.Top
    Width2 = Object2.Width
    Height2 = Object2.Height
    
    If (X1 + Width1 >= X2 And X1 <= X2 + Width2) And (Y1 + Height1 >= Y2 And Y1 <= Y2 + Height2) Then
        Collision = True
    Else
        Collision = False
    End If
End Function
